from simrobot import *
#from nxtrobot import *
#from ev3robot import *

RobotContext.useObstacle("sprites/bg.gif", 250, 250)
RobotContext.setStartPosition(310, 470)
RobotContext.showStatusBar(30)

def onButtonHit(buttonID):
    global state
    if buttonID == BrickButton.ID_LEFT:
        state = "LEFT"
    elif buttonID == BrickButton.ID_RIGHT:
        state = "RIGHT"
    elif buttonID == BrickButton.ID_ENTER:
        state = "RUN"

def pressCallback(port):
    global startTime
    dt = time.clock() - startTime # time since last hit in s
    print int(1000 * dt) # in ms
    gear.backward(backTime)
    if dt > 2: 
        memory.append(0) # save we turn left
        gear.left(turnTime) 
    
    else:
        memory.pop() # discard node
        memory.append(1) # save we turn right
        gear.right(2 * turnTime)

    print memory
    gear.forward()
    startTime = time.clock()  
     
moveTime = 5000
turnTime = 580
backTime = 800
memory = []        
robot = LegoRobot(buttonHit = onButtonHit)
gear = Gear()
ts = TouchSensor(SensorPort.S3, pressed = pressCallback)      
robot.addPart(ts)
startTime = time.clock()
robot.addPart(gear)
gear.setSpeed(50)
state = "FORWARD"

while not robot.isEscapeHit():
    if state == "FORWARD":
        gear.forward(moveTime)
        state = "STOPPED"
    elif state == "LEFT":
        memory.append(0)
        robot.drawString(str(memory), 0, 1)
        gear.left(turnTime)
        gear.forward(moveTime)
        state = "STOPPED"
    elif state == "RIGHT":
        memory.append(1)
        robot.drawString(str(memory), 0, 1)
        gear.right(turnTime)
        gear.forward(moveTime)
        state = "STOPPED"
    elif state == "RUN":
        robot.drawString("Executing memory", 0, 1)
        robot.drawString(str(memory), 0, 2)
        robot.reset()
        robot.drawString("Moving forward", 0, 3)
        gear.forward(moveTime)
        for k in memory:
            if k == 0:
                robot.drawString("Turning left", 0, 3)
                gear.left(turnTime)
            else:          
                robot.drawString("Turning right", 0, 3)
                gear.right(turnTime)
            robot.drawString("Moving forward", 0, 3)
            gear.forward(moveTime)
        gear.stop()  
        robot.drawString("All done", 0, 3)
        state = "STOPPED"
robot.exit()

